Subject: bug#17598: Emacs pretest 24.3.91 - AIX - SIGSEV when customize

From: Gilles PION <[email-masked]>
Date: Wed, 28 May 2014 18:40:37 +0200

> > $ MALLOCTYPE=debug MALLOEBUG=validate_ptrs  ./emacs-24.3.91/src/temacs
> > --no-site-file  --no-init-file
> > Fatal error 11: Segmentation violationMemory fault
> >
> 
> Have you gone back to the 24.3.91 unexaix.c (with the short fix I sent 
> you), or are you using the much bigger change I sent you later?  For now 

> I'll assume the former.  Also, I assume you're still configuring with 
> --enable-checking=all.
I was using the latest unexaix.c, going back to previous one now

> 
> Unfortunately AIX uses the relocating allocator in ralloc.c, not the 
> system malloc, so MALLOCTYPE and MALLOCDEBUG (misspelled above) aren't 
> likely to be helpful.  If you want to try the system malloc, please 
> comment out "#define REL_ALLOC 1" in src/config.h, change "#undef 
> SYSTEM_MALLOC" to "#define SYSTEM_MALLOC 1" in the same file, and 
> comment out "RALLOC_OBJ=ralloc.o" in src/Makefile (though now of course 
> we're debugging a different program....).

OK, recompiling with those fixes (after configuring using "CFLAGS="-O0 
-g3" ):
1rst step: ./configure
2nd step: fix src/config.h as indicated
3rd step make

> 
> Also, did you actually use "MALLOEBUG"?  That looks like a typo.
You're right, sorry.

> 
> Once you've fixed the above, how about this?
> 
> MALLOCTYPE=debug 
> MALLOCDEBUG=postfree_checking,validate_ptrs,stack_depth:1000 ./temacs -Q

$ MALLOCTYPE=debug 
MALLOCDEBUG=postfree_checking,validate_ptrs,stack_depth:1000 ./temacs -Q
Fatal error 11: Segmentation violationMemory fault

> 
> or this?
> 
> gdb temacs
> (gdb) set env MALLOCTYPE debug
> (gdb) set env MALLOCDEBUG 
postfree_checking,validate_ptrs,stack_depth:200
> (gdb) run -Q

(gdb) set env MALLOCTYPE debug
(gdb) set env MALLOCDEBUG postfree_checking,validate_ptrs,stack_depth:200
(gdb) run -Q
Starting program: 
/sg/paxdev01/D1stunix/src/emacs/24.3.91/emacs-24.3.91/src/temacs -Q
[New Thread 1]

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 1]
0xd0128c78 in extend_brk () from /usr/lib/libc.a(shr.o)
(gdb) where
#0  0xd0128c78 in extend_brk () from /usr/lib/libc.a(shr.o)

> 
> Please also try with the "-nw" option, e.g., "./temacs -Q -nw" or "run 
> -Q -nw".
It's the same 

Note that  the immediate crash occurs only when MALLOC* variables are 
defined.

> 
> A couple of issues that may or may not be related.  On my AIX 7 host I 
> have to configure --with-jpeg=no --with-png=no --with-gif=no 
> --with-tiff=no because those libraries are not installed.  On my 
> platform pkg-config dumps core (don't know why) so I'm not using any of 
> the fancy libraries you're probably using.  This (along with the fact 
> that I can't run X) makes it hard for me to reproduce the problem.

I understand, I've also disabled graphic libraries execpt png (using a 
emacs dedicated version)

I'm on aix 6.1, since I've been unable to compile on AIX 7.1:

configure: error: Emacs does not support `powerpc-ibm-aix7.1.0.0' systems.
If you think it should, please send a report to [email-masked].
Check `etc/MACHINES' for recognized configuration names.

Used gcc binary from 6.1 there ^^^

Since I'missing native 7.1 compatible compiler to re-boostrap gcc.

NB: I won't be reachable at my office tomorrow, will return only friday

Next week, won't be very available until Thursday too.

--
Gilles

                                                                   

. Si vous n'êtes pas destinataires de ce message, merci d'avertir
l'expéditeur de l'erreur de distribution et de le détruire
immédiatement.
Ce message contient des informations confidentielles ou appartenant
a La Française des Jeux. Il est établi a l'intention exclusive de
ses destinataires. Toute divulgation, utilisation, diffusion ou
reproduction (totale ou partielle) de ce message ou des
informations qu'il contient, doit être préalablement autorisée.
Tout message électronique est susceptible d'altération et son
intégrité ne peut etre assurée. La Française des Jeux décline toute
responsabilité au titre de ce message s'il a été modifie ou
falsifie.